%define major 7
%define libname %mklibname gearman %{major}
%define develname %mklibname gearman -d

Summary:	Gearman Server and C Library
Name:		gearmand
Version:	0.39
Release:	1
License:	BSD
Group:		System/Servers
URL:		http://www.gearman.org/
Source0:	http://launchpad.net/gearmand/trunk/%{version}/+download/gearmand-%{version}.tar.gz
Source1:        gearmand.init
Source2:        gearmand.sysconfig
Source3:        gearmand.logrotate
Patch0:		gearmand-0.39-drizzle_header_fix.patch
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(pre):  rpm-helper
Requires(postun): rpm-helper
BuildRequires:	boost-devel
BuildRequires:	doxygen
BuildRequires:	drizzle1-client-devel
BuildRequires:	ext2fs-devel
BuildRequires:	hiredis-devel
BuildRequires:	pkgconfig(libevent)
BuildRequires:	pkgconfig(libmemcached) >= 1.0
BuildRequires:	pkgconfig(uuid)
BuildRequires:	lzmalib-devel
BuildRequires:	memcached >= 1.4.9
BuildRequires:	openssl-devel
BuildRequires:	postgresql-libs-devel >= 9.0
BuildRequires:	tokyocabinet-devel

%description
Gearman provides a generic framework to farm out work to other machines,
dispatching function calls to machines that are better suited to do work, to do
work in parallel, to load balance processing, or to call functions between
languages.

%package -n	%{libname}
Summary:	Shared Gearman Client Library
Group:		System/Libraries

%description -n	%{libname}
Gearman provides a generic framework to farm out work to other machines,
dispatching function calls to machines that are better suited to do work, to do
work in parallel, to load balance processing, or to call functions between
languages.

This package contains the Client Library.

%package -n	%{develname}
Summary:	Development files for the Gearman Server and C Library
Group:		Development/C
Requires:	%{libname} >= %{version}
Provides:	gearman-devel = %{EVRD}

%description -n	%{develname}
Development files for the Gearman Server and C Library.

%prep

%setup -q
%patch0 -p1

cp %{SOURCE1} gearmand.init
cp %{SOURCE2} gearmand.sysconfig
cp %{SOURCE3} gearmand.logrotate

%build
%serverbuild

%configure2_5x \
    --enable-shared \
    --disable-static \
    --with-memcached=%{_bindir}/memcached \
    --with-memcached_sasl=%{_bindir}/memcached

# nuke rpath, fugly autopoo
perl -pi -e "s|^BOOST_LDPATH.*|BOOST_LDPATH=%{_libdir}|g" Makefile
perl -pi -e "s|^BOOST_PROGRAM_OPTIONS_LDFLAGS.*|BOOST_PROGRAM_OPTIONS_LDFLAGS=-L%{_libdir}|g" Makefile
perl -pi -e "s|^BOOST_PROGRAM_OPTIONS_LDPATH.*|BOOST_PROGRAM_OPTIONS_LDPATH=%{_libdir}|g" Makefile
perl -pi -e "s|^BOOST_THREAD_LDFLAGS.*|BOOST_THREAD_LDFLAGS=-L%{_libdir}|g" Makefile
perl -pi -e "s|^BOOST_THREAD_LDPATH.*|BOOST_THREAD_LDPATH=%{_libdir}|g" Makefile

%make

#%%check
#make check

%install
rm -rf %{buildroot}

# weird makefile poo
make DESTDIR=%{buildroot} install-exec-am install-data-am

# don't fiddle with the initscript!
export DONT_GPRINTIFY=1

install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}/var/log/%{name}
install -d %{buildroot}/var/run/%{name}

install -m0755 gearmand.init %{buildroot}%{_initrddir}/%{name}
install -m0644 gearmand.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -m0644 gearmand.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

touch %{buildroot}/var/log/%{name}/gearmand.log

# (oe) avoid pulling 32 bit libraries on 64 bit arch
%if "%{_lib}" == "lib64"
perl -pi -e "s|-L/usr/lib\b|-L%{_libdir}|g" %{buildroot}%{_libdir}/pkgconfig/*.pc
%endif

# cleanup
rm -f %{buildroot}%{_libdir}/*.*a

%pre
%_pre_useradd %{name} /dev/null /bin/false

%postun
%_postun_userdel %{name}

%post
%create_ghostfile /var/log/%{name}/gearmand.log %{name} %{name} 0640
%_post_service %{name}

%preun
%_preun_service %{name}

%files
%defattr(-, root, root)
%attr(0755,root,root) %{_initrddir}/%{name}
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_bindir}/gearadmin
%{_bindir}/gearman
%{_sbindir}/gearmand
%{_mandir}/man1/gear*
%{_mandir}/man8/gear*
%attr(0711,%{name},%{name}) %dir /var/log/%{name}
%attr(0711,%{name},%{name}) %dir /var/run/%{name}
%ghost %attr(0640,%{name},%{name}) /var/log/%{name}/gearmand.log

%files -n %{libname}
%doc AUTHORS ChangeLog COPYING README
%defattr(-, root, root)
%{_libdir}/lib*.so.%{major}*

%files -n %{develname}
%defattr(-, root, root)
%dir %{_includedir}/libgearman
%{_includedir}/libgearman/*.h*
%{_includedir}/libgearman-1.0
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/gearmand.pc
%{_mandir}/man3/gear*
%{_mandir}/man3/libgearman.3*


%changelog
* Fri Sep 21 2012 Dmitry Mikhirev <dmikhirev@mandriva.org> 0.39-1
+ Revision: 817273
- update to 0.39

* Thu Apr 12 2012 Oden Eriksson <oeriksson@mandriva.com> 0.32-1
+ Revision: 790375
- 0.32

* Sun Apr 01 2012 Bernhard Rosenkraenzer <bero@bero.eu> 0.29-1
+ Revision: 788569
- Build for boost 1.49
- Update to 0.29

* Mon Jan 30 2012 Oden Eriksson <oeriksson@mandriva.com> 0.28-1
+ Revision: 769825
- 0.28

* Sun Nov 06 2011 Oden Eriksson <oeriksson@mandriva.com> 0.25-1
+ Revision: 722494
- fix linkage
- various fixes
- 0.25

* Sun Jul 17 2011 Oden Eriksson <oeriksson@mandriva.com> 0.23-1
+ Revision: 690174
- 0.23

* Tue Jun 21 2011 Oden Eriksson <oeriksson@mandriva.com> 0.22-1
+ Revision: 686450
- fix deps
- bump major
- 0.22
- 0.20

* Wed Mar 16 2011 Oden Eriksson <oeriksson@mandriva.com> 0.18-1
+ Revision: 645640
- 0.18

* Mon Mar 14 2011 Funda Wang <fwang@mandriva.org> 0.17-2
+ Revision: 644478
- rebuild for new boost

* Sat Mar 12 2011 Oden Eriksson <oeriksson@mandriva.com> 0.17-1
+ Revision: 643995
- 0.17

* Thu Feb 24 2011 Oden Eriksson <oeriksson@mandriva.com> 0.16-1
+ Revision: 639701
- 0.16

* Tue Feb 15 2011 Oden Eriksson <oeriksson@mandriva.com> 0.15-1
+ Revision: 637866
- 0.15

* Sun Oct 10 2010 Oden Eriksson <oeriksson@mandriva.com> 0.14-2mdv2011.0
+ Revision: 584643
- rebuilt against new libmemcached

* Mon Aug 09 2010 Oden Eriksson <oeriksson@mandriva.com> 0.14-1mdv2011.0
+ Revision: 568083
- 0.14

* Sat Apr 24 2010 Funda Wang <fwang@mandriva.org> 0.13-2mdv2010.1
+ Revision: 538457
- rebuild for libmemcached 0.40

* Thu Apr 08 2010 Oden Eriksson <oeriksson@mandriva.com> 0.13-1mdv2010.1
+ Revision: 532893
- 0.13

* Tue Feb 23 2010 Oden Eriksson <oeriksson@mandriva.com> 0.12-1mdv2010.1
+ Revision: 510163
- 0.12

* Wed Jan 13 2010 Oden Eriksson <oeriksson@mandriva.com> 0.11-2mdv2010.1
+ Revision: 490981
- rebuilt against new libmemcached.so.4

* Wed Dec 09 2009 Oden Eriksson <oeriksson@mandriva.com> 0.11-1mdv2010.1
+ Revision: 475232
- whoops! the major bumped to 3
- 0.11

* Fri Oct 02 2009 Oden Eriksson <oeriksson@mandriva.com> 0.10-1mdv2010.0
+ Revision: 452628
- 0.10
- new major (2)
- fix deps
- new sub package (server libs)

* Fri Jul 31 2009 Frederik Himpe <fhimpe@mandriva.org> 0.9-1mdv2010.0
+ Revision: 405218
- update to new version 0.9

* Sat Jul 11 2009 Oden Eriksson <oeriksson@mandriva.com> 0.8-1mdv2010.0
+ Revision: 394825
- 0.8

* Sat Jul 11 2009 Oden Eriksson <oeriksson@mandriva.com> 0.7-2mdv2010.0
+ Revision: 394778
- rebuilt against new libmemcached

* Thu Jul 02 2009 Oden Eriksson <oeriksson@mandriva.com> 0.7-1mdv2010.0
+ Revision: 391818
- fix deps
- import gearmand


* Wed Jul 01 2009 Oden Eriksson <oeriksson@mandriva.com> 0.7-1mdv2009.0
- initial Mandriva package
